(*
    This file is part of ML::AbstractUI - an abstract user interface
    API with a crossplatform implementation in Standard ML.

    Copyright (C) 1999 ANOQ of the Sun (alias Johnny Andersen).
    
    E-mail: anoq@HardcoreProcessing.com

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    As a special exception, if you do not do anything which is not in
    the spirit of the GNU Library General Public License, you are not
    required to physically compile this software into a separate library,
    since this is generally not possible with current Stanard ML compilers.
    However if you do something which is not in the spirit of the
    GNU Library General Public License you will have to follow the
    licence perpetually - thus disallowing you to use it for any
    commercial purposes at all.

    If you are interested in a warranty or commercial support for this
    software, contact Hardcore Processing <sales@HardcoreProcessing.com>
    for more information.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*)

(* This structure is not in SML/NJ, so it will be emulated... *)
structure IntVector : MONO_VECTOR =
  struct
    type vector = int Vector.vector
    type elem = int
    val maxLen = Vector.maxLen 
    val fromList = Vector.fromList 
    val tabulate = Vector.tabulate 
    val length = Vector.length 
    val sub = Vector.sub
    val extract = Vector.extract 
    val concat = Vector.concat 
    val mapi = Vector.mapi 
    val map = Vector.map 
    val appi = Vector.appi 
    val app = Vector.app
    val foldli = Vector.foldli
    val foldri = Vector.foldri
    val foldl = Vector.foldl 
    val foldr = Vector.foldr
  end

(* This structure is not in SML/NJ, so it will be emulated... *)
structure StringVector : MONO_VECTOR =
  struct
    type vector = string Vector.vector
    type elem = string
    val maxLen = Vector.maxLen 
    val fromList = Vector.fromList 
    val tabulate = Vector.tabulate 
    val length = Vector.length 
    val sub = Vector.sub
    val extract = Vector.extract 
    val concat = Vector.concat 
    val mapi = Vector.mapi 
    val map = Vector.map 
    val appi = Vector.appi 
    val app = Vector.app
    val foldli = Vector.foldli
    val foldri = Vector.foldri
    val foldl = Vector.foldl 
    val foldr = Vector.foldr
  end
